/*!
 * segment-display.js
 *
 * Copyright 2012, Rüdiger Appel
 * http://www.3quarks.com
 * Published under Creative Commons 3.0 License.
 *
 * Date: 2012-02-14
 * Version: 1.0.0
 *
 * Dokumentation: http://www.3quarks.com/de/Segmentanzeige
 * Documentation: http://www.3quarks.com/en/SegmentDisplay
 */
;SegmentDisplay.SevenSegment=7;SegmentDisplay.FourteenSegment=14;SegmentDisplay.SixteenSegment=16;SegmentDisplay.SymmetricCorner=0;SegmentDisplay.SquaredCorner=1;SegmentDisplay.RoundedCorner=2;function SegmentDisplay(a){this.displayId=a;this.pattern="##:##:##";this.value="12:34:56";this.digitHeight=20;this.digitWidth=10;this.digitDistance=2.5;this.displayAngle=12;this.segmentWidth=2.5;this.segmentDistance=0.2;this.segmentCount=SegmentDisplay.SevenSegment;this.cornerType=SegmentDisplay.RoundedCorner;this.colorOn="rgb(233, 93, 15)";this.colorOff="rgb(75, 30, 5)"}SegmentDisplay.prototype.setValue=function(a){this.value=a;this.draw()};SegmentDisplay.prototype.draw=function(){var l=document.getElementById(this.displayId);if(l){var b=l.getContext("2d");if(b){b.clearRect(0,0,l.width,l.height);b.fillStyle="#fff";b.fillRect(0,0,l.width,l.height);var a=0;var k=true;if(this.pattern){for(var g=0;g<this.pattern.length;g++){var m=this.pattern.charAt(g).toLowerCase();if(m=="#"){a+=this.digitWidth}else{if(m=="."||m==":"){a+=this.segmentWidth}else{if(m!=" "){return}}}a+=k?0:this.digitDistance;k=false}}if(a<=0){return}var e=-1*Math.max(-45,Math.min(45,this.displayAngle));var o=Math.tan((e*Math.PI)/180);var d=Math.min(l.width/(a+Math.abs(o*this.digitHeight)),l.height/this.digitHeight);var j=(l.width-(a+o*this.digitHeight)*d)/2;var f=(l.height-this.digitHeight*d)/2;b.save();b.translate(j,f);b.scale(d,d);b.transform(1,0,o,1,0,0);var h=0;var q=(this.value)?this.value.length:0;for(var g=0;g<this.pattern.length;g++){var p=this.pattern.charAt(g);var n=(g<q)?this.value.charAt(g).toLowerCase():" ";h+=this.drawDigit(b,h,p,n)}b.restore()}}};SegmentDisplay.prototype.drawDigit=function(b,j,A,o){switch(A){case"#":var a=Math.sqrt(this.segmentWidth*this.segmentWidth/2);var n=Math.sqrt(this.segmentDistance*this.segmentDistance/2);var m=n/2;var l=(this.segmentWidth-n)*Math.sin((45*Math.PI)/180);var k=l/2;var i=(this.digitHeight-3*this.segmentWidth)/2;var u=(this.digitWidth-3*this.segmentWidth)/2;var z=this.segmentWidth/2;var v=this.digitWidth/2;if(this.segmentCount==16){var q=j;var p=0;b.fillStyle=this.getSegmentColor(o,null,"02356789abcdefgiopqrstz@%");b.beginPath();switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.moveTo(q+z+n,p+z);b.lineTo(q+this.segmentWidth+n,p);break;case SegmentDisplay.SquaredCorner:b.moveTo(q+z+m,p+z-m);b.lineTo(q+this.segmentWidth,p);break;default:b.moveTo(q+this.segmentWidth-l,p+this.segmentWidth-l-n);b.quadraticCurveTo(q+this.segmentWidth-k,p,q+this.segmentWidth,p)}b.lineTo(q+v-n-z,p);b.lineTo(q+v-n,p+z);b.lineTo(q+v-n-z,p+this.segmentWidth);b.lineTo(q+this.segmentWidth+n,p+this.segmentWidth);b.fill();var q=j;var p=0;b.fillStyle=this.getSegmentColor(o,null,"02356789abcdefgiopqrstz@");b.beginPath();b.moveTo(q+this.digitWidth-this.segmentWidth-n,p+this.segmentWidth);b.lineTo(q+v+n+z,p+this.segmentWidth);b.lineTo(q+v+n,p+z);b.lineTo(q+v+n+z,p);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q+this.digitWidth-this.segmentWidth-n,p);b.lineTo(q+this.digitWidth-z-n,p+z);break;case SegmentDisplay.SquaredCorner:b.lineTo(q+this.digitWidth-this.segmentWidth,p);b.lineTo(q+this.digitWidth-z-m,p+z-m);break;default:b.lineTo(q+this.digitWidth-this.segmentWidth,p);b.quadraticCurveTo(q+this.digitWidth-this.segmentWidth+k,p,q+this.digitWidth-this.segmentWidth+l,p+this.segmentWidth-l-n)}b.fill()}else{var q=j;var p=0;b.fillStyle=this.getSegmentColor(o,"02356789acefp","02356789abcdefgiopqrstz@");b.beginPath();switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.moveTo(q+z+n,p+z);b.lineTo(q+this.segmentWidth+n,p);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p);b.lineTo(q+this.digitWidth-z-n,p+z);break;case SegmentDisplay.SquaredCorner:b.moveTo(q+z+m,p+z-m);b.lineTo(q+this.segmentWidth,p);b.lineTo(q+this.digitWidth-this.segmentWidth,p);b.lineTo(q+this.digitWidth-z-m,p+z-m);break;default:b.moveTo(q+this.segmentWidth-l,p+this.segmentWidth-l-n);b.quadraticCurveTo(q+this.segmentWidth-k,p,q+this.segmentWidth,p);b.lineTo(q+this.digitWidth-this.segmentWidth,p);b.quadraticCurveTo(q+this.digitWidth-this.segmentWidth+k,p,q+this.digitWidth-this.segmentWidth+l,p+this.segmentWidth-l-n)}b.lineTo(q+this.digitWidth-this.segmentWidth-n,p+this.segmentWidth);b.lineTo(q+this.segmentWidth+n,p+this.segmentWidth);b.fill()}q=j+this.digitWidth-this.segmentWidth;p=0;b.fillStyle=this.getSegmentColor(o,"01234789adhpy","01234789abdhjmnopqruwy");b.beginPath();switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.moveTo(q+z,p+z+n);b.lineTo(q+this.segmentWidth,p+this.segmentWidth+n);break;case SegmentDisplay.SquaredCorner:b.moveTo(q+z+m,p+z+m);b.lineTo(q+this.segmentWidth,p+this.segmentWidth);break;default:b.moveTo(q+l+n,p+this.segmentWidth-l);b.quadraticCurveTo(q+this.segmentWidth,p+this.segmentWidth-k,q+this.segmentWidth,p+this.segmentWidth)}b.lineTo(q+this.segmentWidth,p+i+this.segmentWidth-n);b.lineTo(q+z,p+i+this.segmentWidth+z-n);b.lineTo(q,p+i+this.segmentWidth-n);b.lineTo(q,p+this.segmentWidth+n);b.fill();q=j+this.digitWidth-this.segmentWidth;p=i+this.segmentWidth;b.fillStyle=this.getSegmentColor(o,"013456789abdhnouy","01346789abdghjmnoqsuw@","%");b.beginPath();b.moveTo(q,p+this.segmentWidth+n);b.lineTo(q+z,p+z+n);b.lineTo(q+this.segmentWidth,p+this.segmentWidth+n);b.lineTo(q+this.segmentWidth,p+i+this.segmentWidth-n);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q+z,p+i+this.segmentWidth+z-n);b.lineTo(q,p+i+this.segmentWidth-n);break;case SegmentDisplay.SquaredCorner:b.lineTo(q+z+m,p+i+this.segmentWidth+z-m);b.lineTo(q,p+i+this.segmentWidth-n);break;default:b.quadraticCurveTo(q+this.segmentWidth,p+i+this.segmentWidth+k,q+l+n,p+i+this.segmentWidth+l);b.lineTo(q,p+i+this.segmentWidth-n)}b.fill();if(this.segmentCount==16){q=j;p=this.digitHeight-this.segmentWidth;b.fillStyle=this.getSegmentColor(o,null,"0235689bcdegijloqsuz_=@");b.beginPath();b.moveTo(q+this.segmentWidth+n,p);b.lineTo(q+v-n-z,p);b.lineTo(q+v-n,p+z);b.lineTo(q+v-n-z,p+this.segmentWidth);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q+this.segmentWidth+n,p+this.segmentWidth);b.lineTo(q+z+n,p+z);break;case SegmentDisplay.SquaredCorner:b.lineTo(q+this.segmentWidth,p+this.segmentWidth);b.lineTo(q+z+m,p+z+m);break;default:b.lineTo(q+this.segmentWidth,p+this.segmentWidth);b.quadraticCurveTo(q+this.segmentWidth-k,p+this.segmentWidth,q+this.segmentWidth-l,p+l+n);b.lineTo(q+this.segmentWidth-l,p+l+n)}b.fill();q=j;p=this.digitHeight-this.segmentWidth;b.fillStyle=this.getSegmentColor(o,null,"0235689bcdegijloqsuz_=@","%");b.beginPath();b.moveTo(q+v+n+z,p+this.segmentWidth);b.lineTo(q+v+n,p+z);b.lineTo(q+v+n+z,p);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q+this.digitWidth-z-n,p+z);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p+this.segmentWidth);break;case SegmentDisplay.SquaredCorner:b.lineTo(q+this.digitWidth-z-m,p+z+m);b.lineTo(q+this.digitWidth-this.segmentWidth,p+this.segmentWidth);break;default:b.lineTo(q+this.digitWidth-this.segmentWidth+l,p+l+n);b.quadraticCurveTo(q+this.digitWidth-this.segmentWidth+k,p+this.segmentWidth,q+this.digitWidth-this.segmentWidth,p+this.segmentWidth)}b.fill()}else{q=j;p=this.digitHeight-this.segmentWidth;b.fillStyle=this.getSegmentColor(o,"0235689bcdelotuy_","0235689bcdegijloqsuz_=@");b.beginPath();b.moveTo(q+this.segmentWidth+n,p);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q+this.digitWidth-z-n,p+z);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p+this.segmentWidth);b.lineTo(q+this.segmentWidth+n,p+this.segmentWidth);b.lineTo(q+z+n,p+z);break;case SegmentDisplay.SquaredCorner:b.lineTo(q+this.digitWidth-z-m,p+z+m);b.lineTo(q+this.digitWidth-this.segmentWidth,p+this.segmentWidth);b.lineTo(q+this.segmentWidth,p+this.segmentWidth);b.lineTo(q+z+m,p+z+m);break;default:b.lineTo(q+this.digitWidth-this.segmentWidth+l,p+l+n);b.quadraticCurveTo(q+this.digitWidth-this.segmentWidth+k,p+this.segmentWidth,q+this.digitWidth-this.segmentWidth,p+this.segmentWidth);b.lineTo(q+this.segmentWidth,p+this.segmentWidth);b.quadraticCurveTo(q+this.segmentWidth-k,p+this.segmentWidth,q+this.segmentWidth-l,p+l+n);b.lineTo(q+this.segmentWidth-l,p+l+n)}b.fill()}q=j;p=i+this.segmentWidth;b.fillStyle=this.getSegmentColor(o,"0268abcdefhlnoprtu","0268acefghjklmnopqruvw@");b.beginPath();b.moveTo(q,p+this.segmentWidth+n);b.lineTo(q+z,p+z+n);b.lineTo(q+this.segmentWidth,p+this.segmentWidth+n);b.lineTo(q+this.segmentWidth,p+i+this.segmentWidth-n);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q+z,p+i+this.segmentWidth+z-n);b.lineTo(q,p+i+this.segmentWidth-n);break;case SegmentDisplay.SquaredCorner:b.lineTo(q+z-m,p+i+this.segmentWidth+z-n+m);b.lineTo(q,p+i+this.segmentWidth);break;default:b.lineTo(q+this.segmentWidth-l-n,p+i+this.segmentWidth+l);b.quadraticCurveTo(q,p+i+this.segmentWidth+k,q,p+i+this.segmentWidth)}b.fill();q=j;p=0;b.fillStyle=this.getSegmentColor(o,"045689abcefhlpty","045689acefghklmnopqrsuvwy@","%");b.beginPath();b.moveTo(q+this.segmentWidth,p+this.segmentWidth+n);b.lineTo(q+this.segmentWidth,p+i+this.segmentWidth-n);b.lineTo(q+z,p+i+this.segmentWidth+z-n);b.lineTo(q,p+i+this.segmentWidth-n);switch(this.cornerType){case SegmentDisplay.SymmetricCorner:b.lineTo(q,p+this.segmentWidth+n);b.lineTo(q+z,p+z+n);break;case SegmentDisplay.SquaredCorner:b.lineTo(q,p+this.segmentWidth);b.lineTo(q+z-m,p+z+m);break;default:b.lineTo(q,p+this.segmentWidth);b.quadraticCurveTo(q,p+this.segmentWidth-k,q+this.segmentWidth-l-n,p+this.segmentWidth-l);b.lineTo(q+this.segmentWidth-l-n,p+this.segmentWidth-l)}b.fill();if(this.segmentCount==7){q=j;p=(this.digitHeight-this.segmentWidth)/2;b.fillStyle=this.getSegmentColor(o,"2345689abdefhnoprty-=");b.beginPath();b.moveTo(q+z+n,p+z);b.lineTo(q+this.segmentWidth+n,p);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p);b.lineTo(q+this.digitWidth-z-n,p+z);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p+this.segmentWidth);b.lineTo(q+this.segmentWidth+n,p+this.segmentWidth);b.fill()}if(this.segmentCount!=7){q=j;p=(this.digitHeight-this.segmentWidth)/2;b.fillStyle=this.getSegmentColor(o,null,"2345689aefhkprsy-+*=","%");b.beginPath();b.moveTo(q+z+n,p+z);b.lineTo(q+this.segmentWidth+n,p);b.lineTo(q+v-n-z,p);b.lineTo(q+v-n,p+z);b.lineTo(q+v-n-z,p+this.segmentWidth);b.lineTo(q+this.segmentWidth+n,p+this.segmentWidth);b.fill();q=j;p=(this.digitHeight-this.segmentWidth)/2;b.fillStyle=this.getSegmentColor(o,null,"234689abefghprsy-+*=@","%");b.beginPath();b.moveTo(q+v+n,p+z);b.lineTo(q+v+n+z,p);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p);b.lineTo(q+this.digitWidth-z-n,p+z);b.lineTo(q+this.digitWidth-this.segmentWidth-n,p+this.segmentWidth);b.lineTo(q+v+n+z,p+this.segmentWidth);b.fill();q=j+v-z;p=0;b.fillStyle=this.getSegmentColor(o,null,"bdit+*","%");b.beginPath();if(this.segmentCount==14){b.moveTo(q,p+this.segmentWidth+this.segmentDistance);b.lineTo(q+this.segmentWidth,p+this.segmentWidth+this.segmentDistance)}else{b.moveTo(q,p+this.segmentWidth+n);b.lineTo(q+z,p+z+n);b.lineTo(q+this.segmentWidth,p+this.segmentWidth+n)}b.lineTo(q+this.segmentWidth,p+i+this.segmentWidth-n);b.lineTo(q+z,p+i+this.segmentWidth+z-n);b.lineTo(q,p+i+this.segmentWidth-n);b.fill();q=j+v-z;p=this.digitHeight;b.fillStyle=this.getSegmentColor(o,null,"bdity+*@","%");b.beginPath();if(this.segmentCount==14){b.moveTo(q,p-this.segmentWidth-this.segmentDistance);b.lineTo(q+this.segmentWidth,p-this.segmentWidth-this.segmentDistance)}else{b.moveTo(q,p-this.segmentWidth-n);b.lineTo(q+z,p-z-n);b.lineTo(q+this.segmentWidth,p-this.segmentWidth-n)}b.lineTo(q+this.segmentWidth,p-i-this.segmentWidth+n);b.lineTo(q+z,p-i-this.segmentWidth-z+n);b.lineTo(q,p-i-this.segmentWidth+n);b.fill();q=j+this.segmentWidth;p=this.segmentWidth;b.fillStyle=this.getSegmentColor(o,null,"mnx\\*");b.beginPath();b.moveTo(q+this.segmentDistance,p+this.segmentDistance);b.lineTo(q+this.segmentDistance+a,p+this.segmentDistance);b.lineTo(q+u-this.segmentDistance,p+i-this.segmentDistance-a);b.lineTo(q+u-this.segmentDistance,p+i-this.segmentDistance);b.lineTo(q+u-this.segmentDistance-a,p+i-this.segmentDistance);b.lineTo(q+this.segmentDistance,p+this.segmentDistance+a);b.fill();q=j+u+2*this.segmentWidth;p=this.segmentWidth;b.fillStyle=this.getSegmentColor(o,null,"0kmvxz/*","%");b.beginPath();b.moveTo(q+u-this.segmentDistance,p+this.segmentDistance);b.lineTo(q+u-this.segmentDistance,p+this.segmentDistance+a);b.lineTo(q+this.segmentDistance+a,p+i-this.segmentDistance);b.lineTo(q+this.segmentDistance,p+i-this.segmentDistance);b.lineTo(q+this.segmentDistance,p+i-this.segmentDistance-a);b.lineTo(q+u-this.segmentDistance-a,p+this.segmentDistance);b.fill();q=j+u+2*this.segmentWidth;p=i+2*this.segmentWidth;b.fillStyle=this.getSegmentColor(o,null,"5knqrwx\\*");b.beginPath();b.moveTo(q+this.segmentDistance,p+this.segmentDistance);b.lineTo(q+this.segmentDistance+a,p+this.segmentDistance);b.lineTo(q+u-this.segmentDistance,p+i-this.segmentDistance-a);b.lineTo(q+u-this.segmentDistance,p+i-this.segmentDistance);b.lineTo(q+u-this.segmentDistance-a,p+i-this.segmentDistance);b.lineTo(q+this.segmentDistance,p+this.segmentDistance+a);b.fill();q=j+this.segmentWidth;p=i+2*this.segmentWidth;b.fillStyle=this.getSegmentColor(o,null,"0vwxz/*","%");b.beginPath();b.moveTo(q+u-this.segmentDistance,p+this.segmentDistance);b.lineTo(q+u-this.segmentDistance,p+this.segmentDistance+a);b.lineTo(q+this.segmentDistance+a,p+i-this.segmentDistance);b.lineTo(q+this.segmentDistance,p+i-this.segmentDistance);b.lineTo(q+this.segmentDistance,p+i-this.segmentDistance-a);b.lineTo(q+u-this.segmentDistance-a,p+this.segmentDistance);b.fill()}return this.digitDistance+this.digitWidth;case".":b.fillStyle=(o=="#")||(o==".")?this.colorOn:this.colorOff;this.drawPoint(b,j,this.digitHeight-this.segmentWidth,this.segmentWidth);return this.digitDistance+this.segmentWidth;case":":b.fillStyle=(o=="#")||(o==":")?this.colorOn:this.colorOff;var p=(this.digitHeight-this.segmentWidth)/2-this.segmentWidth;this.drawPoint(b,j,p,this.segmentWidth);this.drawPoint(b,j,p+2*this.segmentWidth,this.segmentWidth);return this.digitDistance+this.segmentWidth;default:return this.digitDistance}};SegmentDisplay.prototype.drawPoint=function(f,b,g,e){var a=b+e;var c=g+e;var h=e/4;f.beginPath();f.moveTo(a-h,g);f.quadraticCurveTo(a,g,a,g+h);f.lineTo(a,c-h);f.quadraticCurveTo(a,c,a-h,c);f.lineTo(b+h,c);f.quadraticCurveTo(b,c,b,c-h);f.lineTo(b,g+h);f.quadraticCurveTo(b,g,b+h,g);f.fill()};SegmentDisplay.prototype.getSegmentColor=function(f,b,e,a){if(f=="#"){return this.colorOn}else{switch(this.segmentCount){case 7:return(b.indexOf(f)==-1)?this.colorOff:this.colorOn;case 14:return(e.indexOf(f)==-1)?this.colorOff:this.colorOn;case 16:var d=e+(a===undefined?"":a);return(d.indexOf(f)==-1)?this.colorOff:this.colorOn;default:return this.colorOff}}};